/* CrPrgm82.c - 23/09/2002 - Hector Chu */
/* TI-82 CrASH assembly program builder */

#include <stdio.h>
#include <string.h>

int main(int argc, char *argv[])
{
	int     i, c, pnl, length = 3, checksum = 467;
	char	*pname, buffer[20];
	FILE	*src, *dst;

	if (argc == 1)
	{
		printf("CrPrgm82: Supply a program name.\n");
		return 0;
	}
	pname = argv[1];

	sprintf(buffer, "%s.obj", pname);
	if ((src = fopen(buffer, "rb")) == NULL)
	{
		printf("CrPrgm82: Cannot read from %s.\n", buffer);
		return 1;
	}

	sprintf(buffer, "%s.82p", pname);
	if ((dst = fopen(buffer, "wb")) == NULL)
	{
		printf("CrPrgm82: Cannot write to %s.\n", buffer);
		return 1;
	}

	fputs("**TI82**", dst);
	putc(26, dst); putc(10, dst); putc(0, dst);
	fputs("CrASH assembly program made by CRPRGM82   ", dst);

	fseek(dst, 2, 1);
	putc(11, dst); putc(0, dst);
	fseek(dst, 2, 1);
	putc(6, dst); putc(220, dst);

	sprintf(buffer, "%.7s", pname);
	fputs(buffer, dst);
	pnl = strlen(buffer);
	for (i = pnl; i < 7; i++)
		putc(0, dst);
	for (i = 0; i < pnl; i++)
		checksum += buffer[i];

	fseek(dst, 4, 1);
	putc(213, dst); putc(0, dst); putc(17, dst);

	while ((c = getc(src)) != EOF)
	{
		putc(c, dst);
		length++;
		checksum += c;
	}

	fseek(dst, 53, 0);
	putc((length+17)%256, dst); putc((length+17)/256, dst);
	fseek(dst, 2, 1);
	putc((length+2)%256, dst); putc((length+2)/256, dst);

	fseek(dst, 9, 1);
	putc((length+2)%256, dst); putc((length+2)/256, dst);
	putc(length%256, dst); putc(length/256, dst);

	checksum += ((length+2)%256 + (length+2)/256) * 2;
	checksum += length%256 + length/256;
	checksum %= 65535;

	fseek(dst, 0, 2);
	putc(checksum%256, dst); putc(checksum/256, dst);

	printf("CrPrgm82: Wrote to %s.82p = %d bytes.\n", pname, length+pnl+7);
	return 0;
}
